    001/* ===========================================================
    002 * JFreeChart : a free chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jfreechart/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025 * Other names may be trademarks of their respective owners.]
    026 *
    027 * ------------------
    028 * KeyedValues2D.java
    029 * ------------------
    030 * (C) Copyright 2002-2008, by Object Refinery Limited.
    031 *
    032 * Original Author:  David Gilbert (for Object Refinery Limited);
    033 * Contributor(s):   -;
    034 *
    035 * Changes
    036 * -------
    037 * 28-Oct-2002 : Version 1 (DG);
    038 * 12-Jan-2005 : Updated Javadocs (DG);
    039 *
    040 */
    041
    042package org.jfree.data;
    043
    044import java.util.List;
    045
    046/**
    047 * An extension of the {@link Values2D} interface where a unique key is
    048 * associated with the row and column indices.
    049 */
    050public interface KeyedValues2D extends Values2D {
    051
    052    /**
    053     * Returns the row key for a given index.
    054     *
    055     * @param row  the row index (zero-based).
    056     *
    057     * @return The row key.
    058     *
    059     * @throws IndexOutOfBoundsException if <code>row</code> is out of bounds.
    060     */
    061    public Comparable getRowKey(int row);
    062
    063    /**
    064     * Returns the row index for a given key.
    065     *
    066     * @param key  the row key.
    067     *
    068     * @return The row index, or <code>-1</code> if the key is unrecognised.
    069     */
    070    public int getRowIndex(Comparable key);
    071
    072    /**
    073     * Returns the row keys.
    074     *
    075     * @return The keys.
    076     */
    077    public List getRowKeys();
    078
    079    /**
    080     * Returns the column key for a given index.
    081     *
    082     * @param column  the column index (zero-based).
    083     *
    084     * @return The column key.
    085     *
    086     * @throws IndexOutOfBoundsException if <code>row</code> is out of bounds.
    087     */
    088    public Comparable getColumnKey(int column);
    089
    090    /**
    091     * Returns the column index for a given key.
    092     *
    093     * @param key  the column key.
    094     *
    095     * @return The column index, or <code>-1</code> if the key is unrecognised.
    096     */
    097    public int getColumnIndex(Comparable key);
    098
    099    /**
    100     * Returns the column keys.
    101     *
    102     * @return The keys.
    103     */
    104    public List getColumnKeys();
    105
    106    /**
    107     * Returns the value associated with the specified keys.
    108     *
    109     * @param rowKey  the row key (<code>null</code> not permitted).
    110     * @param columnKey  the column key (<code>null</code> not permitted).
    111     *
    112     * @return The value.
    113     *
    114     * @throws UnknownKeyException if either key is not recognised.
    115     */
    116    public Number getValue(Comparable rowKey, Comparable columnKey);
    117
    118}